
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">


<xsl:template match="i">
<emphasis><xsl:apply-templates/></emphasis>
</xsl:template>

<xsl:template match="/classes">
<appendix id="App4Properties">
<title>Object Properties</title>
  <para>
    This appendix lists the properties associated with each type of
    object. The properies are grouped up by the object class, allowing
    for inheritance. For example, a field <emphasis>KBField</emphasis> 
    inherits an item <emphasis>KBItem</emphasis> so it inherits
    the items properties (though in a few cases, inherited properties
    will be hidden). Each property is identified by the text that
    appears in the propertry editor; the internal name, which will be
    needed if you need to access the property directly from a script,
    is shown in brackets.
  </para>
<xsl:apply-templates/>
</appendix>
</xsl:template>

<xsl:template match="/classes/dictionary">
    <xsl:variable name="elemid" select="@element"/>
    <sect1 id="App4_{$elemid}">
    <xsl:choose>
        <xsl:when test="@super!=''">
            <title><xsl:value-of select="@element"/> (subclass of <xsl:value-of select="@super"/>)</title>
        </xsl:when>
        <xsl:otherwise>
            <title><xsl:value-of select="@element"/></title>
        </xsl:otherwise>
    </xsl:choose>
    <para/>
        <xsl:apply-templates/>
    </sect1>
</xsl:template>


<xsl:template match="/classes/dictionary/attribute">
    <xsl:variable name="elemid" select="../@element"/>
    <xsl:variable name="attrid" select="@name"/>
    <sect2 id="App4_{$elemid}_{$attrid}">
        <title><xsl:value-of select="legend"/> (<xsl:value-of select="@name"/>)</title>
        <para>
            <xsl:value-of select="description"/>
        </para>
    </sect2>
</xsl:template>

<xsl:template match="/classes/dictionary/attribute[@language='*']">
</xsl:template>

<xsl:template match="legend" mode="description">
</xsl:template>

<xsl:template match="/classes/dictionary/attribute/nullcheck">
</xsl:template>

<xsl:template match="/classes/dictionary/attribute/extra">
</xsl:template>

</xsl:stylesheet>
