
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">


<xsl:template match="i">
<emphasis><xsl:apply-templates/></emphasis>
</xsl:template>

<xsl:template match="/classes">
<appendix id="App4_py_Properties">
<title>Object Events: Python</title>
  <para>
    This appendix lists the events associated with each type of
    object for the Python scripting language.
  </para>
<xsl:apply-templates/>
</appendix>
</xsl:template>

<xsl:template match="/classes/dictionary">
    <xsl:variable name="elemid" select="@element"/>
    <sect1 id="App4_py_{$elemid}">
    <xsl:choose>
        <xsl:when test="@super!=''">
            <title><xsl:value-of select="@element"/> (subclass of <xsl:value-of select="@super"/>)</title>
        </xsl:when>
        <xsl:otherwise>
            <title><xsl:value-of select="@element"/></title>
        </xsl:otherwise>
    </xsl:choose>
    <para/>
        <xsl:apply-templates/>
    </sect1>
</xsl:template>


<xsl:template match="/classes/dictionary/attribute">
    <xsl:variable name="elemid" select="../@element"/>
    <xsl:variable name="attrid" select="@name"/>
    <sect2 id="App4_py_{$elemid}_{$attrid}">
        <title><xsl:value-of select="legend"/> (<xsl:value-of select="@name"/>)</title>
        <para>
            <xsl:value-of select="description"/>
        </para>
    </sect2>
</xsl:template>

<xsl:template match="legend" mode="description">
    <emphasis>
        <xsl:apply-templates/>
    </emphasis>
</xsl:template>

<xsl:template match="/classes/dictionary/attribute/nullcheck">
</xsl:template>

<xsl:template match="/classes/dictionary/attribute/extra">
</xsl:template>

</xsl:stylesheet>
