
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">


<xsl:template match="/classes">
<appendix id="KJSMethods">
<title>Object Methods: KJS</title>
<para>
</para>
<xsl:apply-templates/>
</appendix>
</xsl:template>

<xsl:template match="/classes/class">
    <xsl:variable name="id" select="@name"/>
    <sect1 id="App5KJS{$id}">
    <xsl:choose>
        <xsl:when test="@super!=''">
            <title><xsl:value-of select="@title"/> (inherits <xsl:value-of select="@super"/>)</title>
        </xsl:when>
        <xsl:otherwise>
            <title><xsl:value-of select="@title"/></title>
        </xsl:otherwise>
    </xsl:choose>
    <para/>
    <xsl:apply-templates/>
    </sect1>
</xsl:template>

<xsl:template match="/classes/class/property">
<sect2>
<title><xsl:value-of select="@name"/> (<xsl:value-of select="@access"/>)</title>
<para>
<xsl:apply-templates mode="description"/>
</para>
</sect2>
</xsl:template>

<xsl:template match="/classes/class/method">
  <sect2>
    <title>
      <xsl:value-of select="return/@type"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="@name"/>
      (
      <xsl:for-each select="arg[position()!=last()]">
        <xsl:value-of select="@type"/>
        <xsl:text> </xsl:text>
        <xsl:value-of select="@name"/>,
      </xsl:for-each>
      <xsl:for-each select="arg[position() =last()]">
        <xsl:value-of select="@type"/>
        <xsl:text> </xsl:text>
        <xsl:value-of select="@name"/>
      </xsl:for-each>
      )
    </title>
    <xsl:if test="string-length(@serverside)>0">
      <para>
        <emphasis>Server-side only method</emphasis>
      </para>
    </xsl:if>
    <para><xsl:value-of select="@comment"/></para>
    <para>
      <itemizedlist mark="closedcircle">
        <xsl:apply-templates/>
      </itemizedlist>
    </para>
    <para>
      <xsl:apply-templates mode="description"/>
    </para>
  </sect2>
</xsl:template>

<xsl:template match="/classes/class/method/return">
<listitem>
<simpara>
Return: <emphasis><xsl:value-of select="@type"/></emphasis>:<xsl:if test="string-length(@comment)>0"><xsl:text> </xsl:text></xsl:if><xsl:value-of select="@comment"/>
</simpara>
</listitem>
</xsl:template>

<xsl:template match="/classes/class/method/arg">
<listitem>
<simpara>
Arg: <emphasis><xsl:value-of select="@type"/></emphasis>: <xsl:value-of select="@comment"/>
</simpara>
</listitem>
</xsl:template>

<xsl:template match="description">
</xsl:template>

<xsl:template mode="description" match="description">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="emphasis">
<emphasis><xsl:apply-templates/></emphasis>
</xsl:template>

<xsl:template match="i">
<emphasis><xsl:apply-templates/></emphasis>
</xsl:template>

<xsl:template match="table">
  <xsl:variable name="cols" select="@cols"/>
  <informaltable>
    <tgroup cols="{$cols}">
      <tbody>
        <xsl:apply-templates/>
      </tbody>
    </tgroup>
  </informaltable>
</xsl:template>

<xsl:template match="tr">
<row>
<xsl:apply-templates/>
</row>
</xsl:template>

<xsl:template match="td">
<entry>
<xsl:apply-templates/>
</entry>
</xsl:template>

</xsl:stylesheet>
