<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:template match="footnote">
    (
        <xsl:apply-templates/>
    )
</xsl:template>

<xsl:template match="footnote/para">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="listitem/simpara">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="para">
    <p>
        <xsl:apply-templates/>
    </p>
</xsl:template>

<xsl:template match="simpara">
    <p>
        <xsl:apply-templates/>
    </p>
</xsl:template>

<xsl:template match="emphasis">
    <i><xsl:apply-templates/></i>
</xsl:template>

<xsl:template match="imagedata">
    <xsl:variable name="fileref"><xsl:value-of select="@fileref"/></xsl:variable>
    <img src="{$fileref}"/>
</xsl:template>

<xsl:template match="informaltable">
    <table border="1">
        <xsl:apply-templates/>
    </table>
</xsl:template>

<xsl:template match="row">
    <tr>
        <xsl:apply-templates/>
    </tr>
</xsl:template>

<xsl:template match="thead/row/entry">
    <td>
        <b>
            <xsl:apply-templates/>
        </b>
    </td>
</xsl:template>

<xsl:template match="tbody/row/entry">
    <td>
        <xsl:apply-templates/>
    </td>
</xsl:template>

<xsl:template match="itemizedlist">
    <ul>
        <xsl:apply-templates/>
    </ul>
</xsl:template>

<xsl:template match="listitem">
    <li>
        <xsl:apply-templates/>
    </li>
</xsl:template>

<xsl:template match="programlisting">
    <pre>
<xsl:apply-templates/>
    </pre>
</xsl:template>

</xsl:stylesheet>
