#!/bin/sh

rm -rf	pdf
mkdir	pdf

kdedir=

[ "$kdedir" = "" ] && {

	[ -d "/opt/kde3/share/apps/ksgmltools2" ] && kdedir=/opt/kde3
	[ -d "/usr/share/apps/ksgmltools2"      ] && kdedir=/usr

}

[ "$kdedir" = "" ] && {

	echo	"mkpdf: cannot locate ksgmltools2"
	exit	1
}


cp -r	${kdedir}/share/apps/ksgmltools2/customization/dtd 	pdf
cp -r	${kdedir}/share/apps/ksgmltools2/customization/entities	pdf
cp -r	${kdedir}/share/apps/ksgmltools2/customization/en	pdf

for dir in chap[1-9] chap[1-9][0-9]
do
	mkdir	pdf/$dir
done

#cp -a	properties pdf

filter=Box

for img in `find chap* -name '*.png'`
do
	case `basename $img`
	in
		i_*)
			cp $img pdf/$img
			;;
		*)
			convert -enhance -geometry 50% -filter $filter $img pdf/$img
			;;
	esac
done


cp	../../build/kde/doc/rekall/*.sgml		pdf
cp	../../build/kde/doc/rekall/index.docbook	pdf

cd	pdf

#xmlto	pdf index.docbook

xmlto	xhtml-nochunks index.docbook
