<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:import href="m_common.xsl"/>

<xsl:template match="/chapter">
    <html>
    <head>
      <xsl:for-each select="title">
        <title>
          <xsl:value-of select="text()"/>
        </title>
      </xsl:for-each>
    </head>
    <body>
        <xsl:apply-templates/>
    </body>
    </html>
</xsl:template>

<xsl:template match="/chapter/title">
    <h1>
        <xsl:apply-templates/>
    </h1>
</xsl:template>


<xsl:template match="footnote">
    (
        <xsl:apply-templates/>
    )
</xsl:template>

<xsl:template match="sect1">
    <xsl:variable name="id"><xsl:value-of select="@id"/></xsl:variable>
    <a href="chap_sect_{$id}.html">
        <xsl:apply-templates mode="section"/>
    </a><br/>
</xsl:template>

<xsl:template mode="section" match="sect1/title">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template mode="section" match="*">
</xsl:template>

</xsl:stylesheet>
