#include	"rk_listbox.moc"

RKListBoxItem::RKListBoxItem
	(	RKListBox	*parent
	)
	:
	m_listBox (parent)
{
}

RKListBoxText::RKListBoxText
	(	RKListBox	*parent,
		const QString	&text
	)
	:
	RKListBoxItem	(parent)
{
	GtkListStore	*store	= m_listBox->gtkListStore () ;
	GtkTreeIter 	m_iter	;

	gtk_list_store_append (store, &m_iter) ;
	gtk_list_store_set    (store, &m_iter, 0, text.latin1(), -1) ;
}


/*  ------------------------------------------------------------------  */

RKListBox::RKListBox
	(	RKWidget	*parent,
		const char	*name
	)
	:
	RKWidget	(gtk_scrolled_window_new(0, 0), parent, name)
{
	m_gtkTreeView	= gtk_tree_view_new () ;
	g_object_set (G_OBJECT(m_gtkTreeView), "headers-visible", (gboolean)false, 0) ;

	gtk_container_add (GTK_CONTAINER(gtkWidget()), m_gtkTreeView) ;
	gtk_widget_show   (m_gtkTreeView) ;

	m_gtkListStore	= 0 ;
}


RKListBox::~RKListBox ()
{
}

void	RKListBox::insertItem
	(	const QString	&text
	)
{
	new RKListBoxText (this, text) ;
}


GtkListStore
	*RKListBox::gtkListStore ()
{
	if (m_gtkListStore == 0)
	{
		m_gtkListStore = gtk_list_store_new (1, G_TYPE_STRING) ;
		gtk_tree_view_set_model (GTK_TREE_VIEW(m_gtkTreeView), GTK_TREE_MODEL(m_gtkListStore)) ;

		GtkCellRenderer   *render = gtk_cell_renderer_text_new() ;
		GtkTreeViewColumn *column = gtk_tree_view_column_new_with_attributes
					    (		"0",
							render,
							"text",		0,
							0
					    )	;

		gtk_tree_view_append_column (GTK_TREE_VIEW(m_gtkTreeView), column) ;
	}

	return	m_gtkListStore ;
}
