#include	"rk_listview.moc"


static	GType	columnTypes[] =
{
	G_TYPE_POINTER,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,
	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING,	G_TYPE_STRING
}	;


/*  RKListViewItem							*/
/*  RKListViewItem							*/
/*		: Constructor for top-level list view item		*/
/*  parent	: RKListView *	 : Parent view				*/
/*  label1, ...	: QString, ...	 : Column text values			*/
/*  (returns)	: RKListViewItem :					*/

RKListViewItem::RKListViewItem
	(	RKListView	*parent,
		QString		label1,
		QString		label2,
		QString		label3,
		QString		label4,
		QString		label5,
		QString		label6,
		QString		label7,
		QString		label8
	)
	:
	m_listView	(parent),
	m_parentItem	(0)
{
	QString  *p[8] ;
	p[0] = &label1 ;
	p[1] = &label2 ;
	p[2] = &label3 ;
	p[3] = &label4 ;
	p[4] = &label5 ;
	p[5] = &label6 ;
	p[6] = &label7 ;
	p[7] = &label8 ;

	gtkInit	(0, p) ;
	m_prevSibling	= m_listView->appendChild (this) ;
}

/*  RKListViewItem							*/
/*  RKListViewItem							*/
/*		: Constructor for top-level list view item		*/
/*  parent	: RKListViewItem * : Parent item			*/
/*  label1, ...	: QString, ...	   : Column text values			*/
/*  (returns)	: RKListViewItem   :					*/

RKListViewItem::RKListViewItem
	(	RKListViewItem	*parent,
		QString		label1,
		QString		label2,
		QString		label3,
		QString		label4,
		QString		label5,
		QString		label6,
		QString		label7,
		QString		label8
	)
	:
	m_listView	(parent->listView()),
	m_parentItem	(parent)
{
	QString  *p[8] ;
	p[0] = &label1 ;
	p[1] = &label2 ;
	p[2] = &label3 ;
	p[3] = &label4 ;
	p[4] = &label5 ;
	p[5] = &label6 ;
	p[6] = &label7 ;
	p[7] = &label8 ;

	gtkInit (m_parentItem->gtkTreeIter(), p) ;
	m_prevSibling	= m_parentItem->appendChild (this) ;
}

/*  RKListViewItem							*/
/*  ~RKListViewItem							*/
/*		: Destructor for list view item				*/
/*  (returns)	:		:					*/

RKListViewItem::~RKListViewItem ()
{
	/* Update the next and previous siblings, if any, so that this	*/
	/* item is unlinked from the chain.				*/
	if (m_nextSibling != 0)
		m_nextSibling->setPrevSibling (m_prevSibling) ;
	if (m_prevSibling != 0)
		m_prevSibling->setNextSibling (m_nextSibling) ;

	/* If thete is no previous sibling then update the parent	*/
	/* (either a list view or an item) that the next sibling is now	*/
	/* its first child.						*/
	if (m_prevSibling == 0)
		if (m_parentItem == 0)
			m_listView  ->setFirstChild (m_nextSibling) ;
		else	m_parentItem->setFirstChild (m_nextSibling) ;

	/* Remove ourselves from the parents tree store ...		*/
	GtkTreeStore	*store	= m_listView != 0 ?
					m_listView  ->gtkTreeStore () :
					m_parentItem->gtkTreeStore () ;
	gtk_tree_store_remove (store, &m_iter) ;
}

/*  RKListViewItem							*/
/*  gtkInit	: Initialise GTK level					*/
/*  parentIter	: GtkTreeIter *	: Iterator for parent if any		*/
/*  labels	: QString **	: List of labels			*/
/*  (returns)	: void		:					*/

void	RKListViewItem::gtkInit
	(	GtkTreeIter	*parentIter,
		QString		**labels
	)
{
	unsigned int	cols	= m_listView->columns	   () ;
	GtkTreeStore	*store	= m_listView->gtkTreeStore () ;

	gtk_tree_store_append	(store, &m_iter, parentIter ) ;
	gtk_tree_store_set	(store, &m_iter, 0, this, -1) ;

	/* Set the column labels. There is a sanity check so that we do	*/
	/* not fall over if there are more than eight columns.		*/
	if (cols > 8) cols = 8 ;
	for (unsigned int idx = 0 ; idx < cols ; idx += 1)
	{
		m_strings[idx] = *labels[idx] ;

		if (!labels[idx]->isNull())
			gtk_tree_store_set (store, &m_iter, idx + 1, labels[idx]->latin1(), -1) ;
	}

	m_expandable	= false	;
	m_expandItem	= 0	;

	m_firstChild	= 0	;
	m_nextSibling	= 0	;
}

/*  RKListViewItem							*/
/*  listView	: Get owning list view					*/
/*  (returns)	: RKListView *	: Owning list view			*/

RKListView
	*RKListViewItem::listView ()
{
	return	m_listView	;
}

/*  RKListViewItem							*/
/*  firstChild	: Get first child item					*/
/*  (returns)	: RKListViewItem * : First child or null if none		*/

RKListViewItem
	*RKListViewItem::firstChild ()
{
	return	m_firstChild == m_expandItem ? 0 : m_firstChild ;
}

/*  RKListViewItem							*/
/*  setOpen	: Expand or collapse item				*/
/*  open	: bool		: True to expand			*/
/*  (returns)	: void		:					*/

void	RKListViewItem::setOpen
	(	bool		open
	)
{
	if (open)
	{
		if ((m_firstChild != 0) && (m_expandItem != 0))
		{
			delete	m_expandItem ;
			m_expandItem = 0 ;
			return	;
		}
	}
}

/*  RKListViewItem							*/
/*  setText	: Set text for a specified column			*/
/*  column	: int		  : Column number			*/
/*  text	: const QString & : Text				*/
/*  (returns)	: void		  :					*/

void	RKListViewItem::setText
	(	int		column,
		const QString	&text
	)
{
	GtkTreeStore	*store	= m_listView->gtkTreeStore () ;
	gtk_tree_store_set (store, &m_iter, column + 1, text.latin1(), -1) ; 
	m_strings[column] = text ;
}

QString	RKListViewItem::text
	(	int		column
	)
	const
{
	return	m_strings[column] ;
}

/*  RKListViewItem							*/
/*  setExpandable							*/
/*		: Set whether emtpy items can be expanded		*/
/*  expandable	: bool		: True to make expandable		*/
/*  (returns)	: void		  :					*/

void	RKListViewItem::setExpandable
	(	bool		expandable
	)
{
	/* If there is no change then return at once, otherwise note	*/
	/* the new state.						*/
	if (expandable == m_expandable)
		return	;

	m_expandable = expandable ;

	/* If expandable and there are no children then we need to	*/
	/* fabricate a dummy item ....					*/
	if (m_expandable && (m_firstChild == 0))
	{
		m_expandItem = new RKListViewItem (this, "", "") ;
		return	;
	}

	/* ... and similarly if going non-expandable ...		*/
	if (!m_expandable && (m_expandItem != 0))
	{
		delete	m_expandItem ;
		m_expandItem = 0 ;
		return	;
	}
}

RKListViewItem
	*RKListViewItem::nextSibling ()
{
	return	m_nextSibling ;
}

void	RKListViewItem::setNextSibling
	(	RKListViewItem	*sibling
	)
{
	m_nextSibling = sibling ;
}

void	RKListViewItem::setPrevSibling
	(	RKListViewItem	*sibling
	)
{
	m_prevSibling = sibling ;
}

void	RKListViewItem::setFirstChild
	(	RKListViewItem	*child
	)
{
	m_firstChild  = child ;
}

RKListViewItem
	*RKListViewItem::appendChild
	(	RKListViewItem	*child
	)
{
	if (!m_expandItem != 0)
	{
		delete	m_expandItem ;
		m_expandItem = 0 ;
	}

	if (m_firstChild == 0)
	{	m_firstChild = child ;
		return	0 ;
	}

	RKListViewItem *p = m_firstChild ;
	RKListViewItem *n = p->nextSibling () ;

	while (n != 0)
	{	p = n ;
		n = n->nextSibling () ;
	}

	p->setNextSibling (child) ;
	return	p ;
}


GtkTreeIter
	*RKListViewItem::gtkTreeIter ()
{
	return	&m_iter	;
}

GtkTreeStore
	*RKListViewItem::gtkTreeStore ()
{
	return	m_listView->gtkTreeStore() ;
}

/*  ------------------------------------------------------------------  */

/*  RKListView								*/
/*  RKListView	: Constructor for list view object			*/
/*  parent	: RKWidget *	: Parent widget				*/
/*  name	: const char *	: Option name				*/
/*  (returns)	: RKListView	:					*/

RKListView::RKListView
	(	RKWidget	*parent,
		const char	*name
	)
	:
	RKWidget (gtk_scrolled_window_new(0, 0), parent, name)
{
	m_gtkTreeView	= gtk_tree_view_new () ;
	gtk_container_add (GTK_CONTAINER(gtkWidget()), m_gtkTreeView) ;
	gtk_widget_show   (m_gtkTreeView) ;


	m_gtkTreeStore	= 0 ;
	m_numCols	= 0 ;
	m_firstChild	= 0 ;

	g_signal_connect
	(	G_OBJECT(m_gtkTreeView),
		"row-expanded",
		G_CALLBACK(sigRowExpanded),
		(gpointer)this
	)	;
	g_signal_connect
	(	G_OBJECT(m_gtkTreeView),
		"button-press-event",
		G_CALLBACK(sigButtonEvent),
		(gpointer)this
	)	;
	g_signal_connect
	(	G_OBJECT(m_gtkTreeView),
		"button-release-event",
		G_CALLBACK(sigButtonEvent),
		(gpointer)this
	)	;
}

RKListView::~RKListView ()
{
}

bool	RKListView::sigRowExpanded
	(	GObject		*object,
		GtkTreeIter	*treeIter,
		GtkTreePath	*treePath,
		gpointer	data
	)
{
	((RKListView *)data)->gtkRowExpanded(treeIter, treePath) ;
	return	true	;
}

bool	RKListView::sigButtonEvent
	(	GObject		*object,
		GdkEventButton	*event,
		gpointer	data
	)
{
	((RKListView *)data)->gtkButtonEvent(event) ;
	return	false	;
}


/*  RKListView								*/
/*  addColumn	: Add a new column					*/
/*  label	: const QString & : Column heading			*/
/*  (returns)	: void		  :					*/

void	RKListView::addColumn
	(	const QString	&label
	)
{
	GtkCellRenderer   *render = gtk_cell_renderer_text_new() ;
	GtkTreeViewColumn *column = gtk_tree_view_column_new_with_attributes
				    (		label.latin1(),
						render,
						"text",		m_numCols + 1,
						0
				    )	;
						
	gtk_tree_view_append_column   (GTK_TREE_VIEW(m_gtkTreeView), column) ;

	m_columns[m_numCols] = column ;
	m_numCols += 1 ;
}

void	RKListView::setOpen
	(	RKListViewItem	*lvi,
		bool		open
	)
{
	lvi->setOpen (open) ;
}

RKListViewItem
	*RKListView::firstChild ()
{
	return	m_firstChild	;
}

void	RKListView::gtkRowExpanded
	(	GtkTreeIter	*iter,
		GtkTreePath	*
	)
{
	RKListViewItem	*lvi	;
	gtk_tree_model_get (GTK_TREE_MODEL(m_gtkTreeStore), iter, 0, &lvi, -1) ;
	setOpen	(lvi, true) ;
}

void	RKListView::gtkButtonEvent
	(	GdkEventButton	*e
	)
{
fprintf	(stderr, "---> %d %d\n", (int)e->x, (int)e->y) ;

	gint			cell_x	;
	gint			cell_y	;
	GtkTreePath		*path	;
	GtkTreeViewColumn	*column	;
	RKListViewItem		*item	= 0 ;

	if (gtk_tree_view_get_path_at_pos
		(	GTK_TREE_VIEW(m_gtkTreeView),
			(int)e->x,
			(int)e->y,
			&path,
			&column,
			&cell_x,
			&cell_y
		))
	{
		gint	depth	 = gtk_tree_path_get_depth   (path) ;
		gint	*indices = gtk_tree_path_get_indices (path) ;

		item = firstChild() ;
		for (gint down = 0 ; (down < depth) && (item != 0) ; down += 1)
		{
			if (down > 0)
				item	= item->firstChild() ;

			for (gint over = 0 ; (over < indices[down]) && (item != 0) ; over += 1)
			{
				item	= item->nextSibling() ;
			}
		}

		gtk_tree_path_free (path) ;
	}

	switch (e->type)
	{
		case GDK_BUTTON_PRESS	:
			fprintf	(stderr, "PRESS\n") ;
			break	;

		case GDK_BUTTON_RELEASE :
			fprintf	(stderr, "RELEASE\n") ;
			break	;

		case GDK_2BUTTON_PRESS	:
			fprintf	(stderr, "2BUTTON\n") ;
			break	;

		default	:
			break	;
	}
}


GtkTreeStore
	*RKListView::gtkTreeStore ()
{
	if (m_gtkTreeStore == 0)
	{
		m_gtkTreeStore = gtk_tree_store_newv (m_numCols + 1, columnTypes) ;
		gtk_tree_view_set_model (GTK_TREE_VIEW(m_gtkTreeView), GTK_TREE_MODEL(m_gtkTreeStore)) ;
	}

	return	m_gtkTreeStore ;
}

int	RKListView::columns ()
{
	return	m_numCols ;
}

RKListViewItem
	*RKListView::appendChild
	(	RKListViewItem	*child
	)
{
	if (m_firstChild == 0)
	{	m_firstChild = child ;
		return	0 ;
	}

	RKListViewItem *p = m_firstChild ;
	RKListViewItem *n = p->nextSibling () ;

	while (n != 0)
	{	p = n ;
		n = n->nextSibling () ;
	}

	p->setNextSibling (child) ;
	return p ;
}

void	RKListView::setFirstChild
	(	RKListViewItem	*child
	)
{
	m_firstChild = child ;
}
