#ifndef		__RK_LISTVIEW_H
#define		__RK_LISTVIEW_H

#include	<rk_gtk.h>
#include	<rk_widget.h>
#include	<qstring.h>


#define	MAXCOLS		32
class	RKListView	;
class	RKListViewItem	;


/*  RKListViewItem							*/
/*  --------------							*/

class	RKListViewItem
{
	RKListView	*m_listView	;
	RKListViewItem	*m_parentItem	;

	RKListViewItem	*m_firstChild	;
	RKListViewItem	*m_prevSibling	;
	RKListViewItem	*m_nextSibling	;

	bool		m_expandable	;
	RKListViewItem	*m_expandItem	;

	GtkTreeIter 	m_iter		;

	QString		m_strings[32]	;

	void		gtkInit		(GtkTreeIter *, QString **) ;
	void		setNextSibling	(RKListViewItem *) ;
	void		setPrevSibling	(RKListViewItem *) ;
	void		setFirstChild	(RKListViewItem *) ;
	RKListViewItem	*appendChild	(RKListViewItem *) ;

	GtkTreeIter	*gtkTreeIter 	() ;
	GtkTreeStore	*gtkTreeStore	() ;

public	:

	RKListViewItem
	(	RKListView	*,
		QString		,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null
	)	;

	RKListViewItem
	(	RKListViewItem	*,
		QString		,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null,
		QString		= QString::null
	)	;

	virtual	~RKListViewItem ()	;

	RKListView		*listView	() ;

	virtual	void		setExpandable	(bool)	;
	virtual	void		setOpen		(bool)	;
	virtual	void		setText		(int, const QString &) ;
	virtual	QString		text		(int)	const	;

	bool			isExpandable	()	const	;

	RKListViewItem		*nextSibling	() ;
	RKListViewItem		*firstChild	() ;

	friend	class	RKListView	;
}	;


/*  RKListView								*/
/*  ---------								*/

class	RKListView : public RKWidget
{
	Q_OBJECT

	static	bool	sigRowExpanded	(GObject *, GtkTreeIter *, GtkTreePath *, gpointer) ;
	static	bool	sigButtonEvent	(GObject *, GdkEventButton *, 		  gpointer) ;

	GtkWidget		*m_gtkTreeView			;
	GtkTreeStore		*m_gtkTreeStore			;

	int			m_numCols			;
	GtkTreeViewColumn	*m_columns[MAXCOLS]		;

	RKListViewItem		*m_firstChild			;

	void	gtkRowExpanded
		(	GtkTreeIter	*,
			GtkTreePath	*
		)	;

	void	gtkButtonEvent
		(	GdkEventButton	*
		)	;

	void			setFirstChild	(RKListViewItem *)	;
	RKListViewItem		*appendChild	(RKListViewItem *)	;
	GtkTreeStore		*gtkTreeStore	() ;

public	:

	RKListView	(RKWidget * = 0, const char * = 0) ;
	~RKListView	()	;


	void			addColumn	(const QString &)	;
	int			columns		()			;

	virtual	void		setOpen		(RKListViewItem *, bool);

	RKListViewItem		*firstChild	() ;

	friend	class	RKListViewItem	;
}	;

#endif		// __RK_LISTVIEW_H
