#include	"rk_tabwidget.moc"

void	RKTabWidget::sigSwitchPage
	(	GtkNotebook	*gtkNotebook,
		GtkNotebookPage	*,
		gint		page_num,
		gpointer	data
	)
{
	GtkWidget *gtkPage = gtk_notebook_get_nth_page (gtkNotebook, page_num) ;
	if (gtkPage == 0) return ;

	RKWidget  *rkPage  = (RKWidget *)g_object_get_data(G_OBJECT(gtkPage),  "RKWidget") ;
	((RKTabWidget *)data)->currentChanged(rkPage) ;
}

RKTabWidget::RKTabWidget
	(	RKWidget	*parent,
		const char	*name,
		WFlags		flags
	)
	:
	RKWidget (gtk_notebook_new (), parent, name, flags)
{
	g_signal_connect
	(	G_OBJECT(gtkWidget()),
		"switch-page",
		G_CALLBACK(sigSwitchPage),
		(gpointer)this
	)	;
}

RKTabWidget::~RKTabWidget ()
{
}

void	RKTabWidget::gtkInsertChild
	(	GtkWidget	*gtkChild
	)
{
	gtk_container_add
	(	GTK_CONTAINER(gtkWidget()),
		gtkChild
	)	;
}

void	RKTabWidget::addTab
	(	RKWidget	*page,
		const QString	&label
	)
{
	GtkNotebook *gtkNotebook = GTK_NOTEBOOK(gtkWidget()) ;
	GtkWidget   *gtkPage	 = page->gtkWidget()	     ;
	gint	    pageno	 = gtk_notebook_page_num (gtkNotebook, gtkPage) ;

	g_object_ref   (G_OBJECT(page->gtkWidget())) ;

	if (pageno >= 0)
		gtk_notebook_remove_page (gtkNotebook, pageno) ;
	else	gtk_widget_unparent      (gtkPage) ;

	gtk_notebook_append_page (gtkNotebook, gtkPage, gtk_label_new (label)) ;

	g_object_unref (G_OBJECT(page->gtkWidget())) ;
}

