#ifndef		__RK_WIDGET_H
#define		__RK_WIDGET_H

#include        <rk_gtk.h>

#include	<qobject.h>
#include	<qpalette.h>

typedef	unsigned int	WFlags		;

class	RKWidget : public QObject
{
	Q_OBJECT

	GtkWidget		*m_gtkWidget	;
	RKWidget		*m_parent	;
	WFlags			m_flags		;

	int			m_minWidth	;
	int			m_minHeight	;

protected :

	RKWidget
	(	GtkWidget	*,
		RKWidget	* = 0,
		const char	* = 0,
		WFlags		= 0
	)	;

	virtual	void	gtkInsertChild	(GtkWidget *)	;


public slots :

	virtual	void	hide		()	;
	virtual	void	show		()	;
	virtual	void	setEnabled	(bool)	;

public	:

	RKWidget
	(	RKWidget	* = 0,
		const char	* = 0,
		WFlags		= 0
	)	;

	virtual	~RKWidget()	;

	void		setMinimumWidth	(int)	;
	void		setMinimumHeight(int)	;
	virtual	void	setMinimumSize	(int, int) ;

	void		reparent	(RKWidget *,	     const QPoint &, bool = false) ;
	virtual	void	reparent	(RKWidget *, WFlags, const QPoint &, bool = false) ;

	virtual	void	setPalette	(const QPalette &) ;

	inline	GtkWidget	*gtkWidget	()
	{
		return	m_gtkWidget	;
	}
	inline	RKWidget	*parentWidget	()
	{
		return	m_parent	;
	}
}	;

#endif		// __RK_WIDGET_H
