#include	<rk_application.h>
#include	<rk_hbox.h>
#include	<rk_vbox.h>
#include	<rk_groupbox.h>
#include	<rk_lineedit.h>
#include	<rk_checkbox.h>
#include	<rk_listbox.h>
#include	<rk_listview.h>
#include	<rk_pushbutton.h>
#include	<rk_tabwidget.h>
#include	<rk_messagebox.h>
#include	<rk_filedialog.h>
#include	<rk_label.h>

#include	"test1.moc"

MyMainWindow::MyMainWindow ()
{
	RKTabWidget	*tab	= new RKTabWidget   (this) ;
	RKHBox		*page1	= new RKHBox	    (tab ) ;
	RKHBox		*page2	= new RKHBox	    (tab ) ;
	RKHBox		*page3	= new RKHBox	    (tab ) ;
	RKHBox		*page4	= new RKHBox	    (tab ) ;
	RKVBox		*page5	= new RKVBox	    (tab ) ;
	RKVBox		*page6	= new RKVBox	    (tab ) ;

	printf	("... page1 %p\n", (void *)page1) ;
	printf	("... page2 %p\n", (void *)page2) ;

	tab->addTab (page1, "LineEdit" ) ;
	tab->addTab (page2, "ListBox"  ) ;
	tab->addTab (page3, "ListView" ) ;
	tab->addTab (page4, "CheckBox" ) ;
	tab->addTab (page5, "Dialogs"  ) ;
	tab->addTab (page6, "GroupBox" ) ;

	m_edit		= new RKLineEdit    (page1) ;
	m_clear		= new RKPushButton  (page1) ;
	m_listbox	= new RKListBox	    (page2) ;
	m_listview	= new RKListView    (page3) ;
	m_checkbox	= new RKCheckBox    (page4) ;
	m_toggle	= new RKPushButton  (page4) ;
	m_yesno		= new RKPushButton  (page5) ;
	m_sorry		= new RKPushButton  (page5) ;
	m_info		= new RKPushButton  (page5) ;
	m_openfile	= new RKPushButton  (page5) ;

	page2->setStretchFactor (m_listbox,  1) ;
	page3->setStretchFactor (m_listview, 1) ;

	m_edit ->setText      ("Hello!"  ) ;
	m_clear->setText      ("Clear"   ) ;
	m_checkbox->setText   ("CheckBox") ;
	m_toggle->setText     ("Toggle"	 ) ;
	m_yesno->setText      ("Yes/No"  ) ;
	m_sorry->setText      ("Sorry"   ) ;
	m_info ->setText      ("Info"    ) ;
	m_openfile->setText   ("OpenFile") ;

	m_listbox->insertItem ("ONE"  ) ;
	m_listbox->insertItem ("TWO"  ) ;
	m_listbox->insertItem ("THREE") ;
	m_listbox->insertItem ("FOUR" ) ;
	m_listbox->insertItem ("FIVE" ) ;
	m_listbox->insertItem ("SIX"  ) ;

	m_listview->addColumn ("First" ) ;
	m_listview->addColumn ("Second") ;
	m_listview->addColumn ("Third" ) ;
	RKListViewItem *l1 = new RKListViewItem (m_listview, "A1", "B1", "C1") ;
	RKListViewItem *l2 = new RKListViewItem (m_listview, "A2", "B2", "C2") ;
	RKListViewItem *l3 = new RKListViewItem (m_listview, "A3", "B3", "C3") ;

	new RKListViewItem (l1, "A11", "B11", "C11") ;
	new RKListViewItem (l1, "A12", "B12", "C12") ;
	new RKListViewItem (l3, "A31", "B31", "C31") ;

	RKGroupBox *gb = new RKGroupBox (2, RKGroupBox::Vertical, "GroupBox", page6) ;
	new RKPushButton ("11", gb) ;
	new RKPushButton ("12", gb) ;
	new RKPushButton ("13", gb) ;
	new RKPushButton ("21", gb) ;
	new RKPushButton ("22", gb) ;
	new RKPushButton ("23", gb) ;

	connect
	(	tab,
		SIGNAL	(currentChanged(RKWidget *)),
		SLOT	(currentChanged(RKWidget *))
	)	;
	connect
	(	m_edit,
		SIGNAL	(textChanged(const QString &)),
		SLOT	(textChanged(const QString &))
	)	;
	connect
	(	m_clear,
		SIGNAL	(clicked()),
		m_edit,
		SLOT	(clear  ())
	)	;
	connect
	(	m_yesno,
		SIGNAL	(clicked()),
		SLOT	(qYesNo())
	)	;
	connect
	(	m_sorry,
		SIGNAL	(clicked()),
		SLOT	(sorry())
	)	;
	connect
	(	m_info,
		SIGNAL	(clicked()),
		SLOT	(info())
	)	;
	connect
	(	m_toggle,
		SIGNAL	(clicked()),
		SLOT	(toggle())
	)	;
	connect
	(	m_openfile,
		SIGNAL	(clicked()),
		SLOT	(openfile())
	)	;
}

void	MyMainWindow::qYesNo ()
{
	int rc = RKMessageBox::questionYesNo ((RKWidget *)sender(), "YesNoText", "YesNoCaption", "Aye", "Nay") ;
	printf	("RKMessageBox::questionYesNo: returned %d\n", rc) ;
}

void	MyMainWindow::sorry ()
{
	RKMessageBox::sorry ((RKWidget *)sender(), "SorryText", "SorryCaption") ;
}

void	MyMainWindow::info ()
{
	RKMessageBox::information ((RKWidget *)sender(), "InfoText", "InfoCaption") ;
}

void	MyMainWindow::toggle ()
{
	m_checkbox->setChecked (!m_checkbox->isChecked()) ;
}

void	MyMainWindow::openfile ()
{
	QString s = KBFileDialog::getOpenFileName ("/tmp", "", (RKWidget *)sender(), "OpenFile") ;
	if (s.isNull())
		printf	("Returned null\n") ;
	else	printf	("Returned [%s]\n", s.latin1()) ;
}

void	MyMainWindow::textChanged
	(	const QString	&text
	)
{
	printf	("... text is [%s]\n", text.latin1()) ;
	m_clear->setEnabled (!text.isEmpty()) ;
}

void	MyMainWindow::currentChanged
	(	RKWidget	*widget
	)
{
	printf	("... current changed to %p\n", (void *)widget) ;
}


int	main
	(	int	argc,
		char	**argv
	)
{
	RKApplication	*app	= new RKApplication (argc, argv) ;
	MyMainWindow	*win	= new MyMainWindow  ;

	return	app->exec () ;
}
