#include	"rk_box.moc"


RKBoxLayout::RKBoxLayout
	(	QWidget			*parent,
		QBoxLayout::Direction	direction,
		bool			noMargin
	)
	:
	QBoxLayout	(parent, direction),
	m_noMargin	(noMargin)
{
}

void	RKBoxLayout::setMargin
	(	int		margin
	)
{
	QBoxLayout::setMargin (m_noMargin ? 0 : margin) ;
}

void	RKBoxLayout::setNoMargin
	(	bool		noMargin
	)
{
	m_noMargin = noMargin ;
}

void	RKBoxLayout::addItem
	(	QLayoutItem	*item
	)
{
	if (qstrcmp (item->widget()->className(), "KBSizerBlob") != 0)
		QBoxLayout::addItem (item) ;
}

RKBox::RKBox
	(	QWidget		*parent,
		const char	*name,
		WFlags		flags
	)
	:
	QFrame	(parent, name, flags)
{
}

bool	RKBox::isNestedBox()
{
	if (parentWidget() != 0)
		return	parentWidget()->inherits("RKBox"	) ||
			parentWidget()->inherits("QWidgetStack" ) ;

	return	false	;
}

void	RKBox::setTracking ()
{
	(new QVBoxLayout (parentWidget()))->addWidget (this) ;
}
