/***************************************************************************
    file	         : rk_modalfilter.h
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__RK_MODALFILTER_H
#define	__RK_MODALFILTER_H


#include	<qobject.h>
#include	<qvaluelist.h>


class	QWidget	;
class	QEvent	;

/*  RKModalFilter							*/
/*  -------------							*/
/*  This class is used when we need to run such that some widget is in	*/
/*  effect modal, but we are not in a modal loop. It will filter out	*/
/*  offending events for any widget other then those that are children	*/
/*  of the specified widget.						*/

class	RKMFFilter
{
public	:

	QWidget		*m_modalTo	;
	bool		m_dropped	;

	RKMFFilter	()		;
	RKMFFilter	(QWidget *)	;
}	;

class	RKModalFilter : public QObject
{
	Q_OBJECT

	QValueList<RKMFFilter>	m_stack	;

	RKModalFilter			()			;
	virtual	bool	eventFilter	(QObject *, QEvent  *)	;

public	:

	void		push		(QWidget *)	;
	void		pop		()		;
	bool		anyDropped	()		;

	static	RKModalFilter	*self	() ;

}	;

#endif	// __RK_MODALFILTER_H
