/***************************************************************************
    file	         : tk_part.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"tk_part.moc"


/*  TKPartManager							*/
/*  TKPartManager: Constructor for part manager wrapper			*/
/*  parent	 : QWidget *	 : Parent widget			*/
/*  name	 : const char *	 : Object name				*/
/*  (returns)	 : TKPartManager :					*/

TKPartManager::TKPartManager
	(	QWidget		*parent,
		const char	*name
	)
	:
	KParts::PartManager (parent, name)
{
	connect
	(	this,
		SIGNAL(activePartChanged(KParts::Part *)),
		this,
		SLOT  (      partChanged(KParts::Part *))
	)	;
}


void	TKPartManager::partChanged
	(	KParts::Part	*part
	)
{
	emit	activePartChanged	((TKPart *)part) ;
}

void	TKPartManager::partActivated
	(	TKPart		*part
	)
{
	emit	activePartActivated	(part) ;
}

static	TKPartManager	*manager	;

/*  TKPartManager							*/
/*  create	: Create an instance of the manager			*/
/*  parent	: QWidget *	  : Parent widget			*/
/*  name	: const char *	  : Object name				*/
/*  (returns)	: TKPartManager	* :					*/

TKPartManager
	*TKPartManager::create
	(	QWidget		*parent,
		const char	*name
	)
{
	/* This (static) method should be called just once to create	*/
	/* a single instance of the manager. The test is for paranoia.	*/
	if (manager == 0)
		manager	= new TKPartManager (parent, name) ;
	return	manager	;
}

/*  TKPartManager							*/
/*  self	: Retrieve part manager instance			*/
/*  (returns)	: TKPartManager	* :					*/

TKPartManager
	*TKPartManager::self ()
{
	return	manager	;
}


/*  ------------------------------------------------------------------	*/

/*  TKPart								*/
/*  TKPart	: Constructor for part wrapper				*/
/*  parent	: QWidget *	: Parent widget				*/
/*  name	: const char *	: Object name				*/
/*  (returns)	: TKPart	 :					*/

TKPart::TKPart
	(	QObject		*parent,
		const char	*name
	)
	:
	KParts::ReadWritePart (parent, name)
{
}

