/***************************************************************************
    file	         : tk_part.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__TK_PART_H
#define	__TK_PART_H

#include	<kmainwindow.h>
#include	<kparts/part.h>
#include	<kparts/mainwindow.h>
#include	<kparts/partmanager.h>


/*  TKPart								*/
/*  ------								*/
/*  This is little more than a wrapper around KParts::ReadWritePart	*/
/*  to provide a system indepenant (source-level) API. There is a	*/
/*  corresponding QT-only implementation.				*/

class	TKPart : public KParts::ReadWritePart
{
	Q_OBJECT

public	:

	TKPart
	(	QObject		*parent = 0,
		const char	*name   = 0
	)	;
}	;

/*  TKPartManager							*/
/*  -------------							*/
/*  Wrapper, similar to above.						*/

class	TKPartManager : public KParts::PartManager
{
	Q_OBJECT

	TKPartManager
	(	QWidget		*parent,
		const char	*name	= 0
	)	;

public slots :

	void	partChanged		(KParts::Part *) ;
	void	partActivated		(TKPart	      *) ;

public	:

	/* Static interface. The main program should call create() to	*/
	/* instantiate a single instance, thereafter self() should be	*/
	/* used to access said instance.				*/
	static	TKPartManager	*create	(QWidget *, const char * = 0) ;
	static	TKPartManager	*self	() ;

signals	:

	void	activePartChanged	(TKPart *) ;
	void	activePartActivated	(TKPart *) ;
}	;

#endif	// __TK_PART_H
