import	os
import	string
import	types


def locateFile (file, dirlist) :

    for dir in dirlist :
        if dir is not None :
            if os.path.isfile (os.path.join (dir, file)) :
                return dir

    return None


#  locateLibrary
#  -------------
#  Locate a library, identified by its prefix, amongst a list of
#  directories.
#
def locateLibrary (prefix, dirlist) :

    for dir in dirlist :
        if dir is not None :

            try    : entries = os.listdir (dir)
            except : continue

            for entry in entries :

                # If the entry name starts with 'lib<prefix>' and ends
                # with the '.a', '.so' or '.dylib' then we have found it.
                # We we presumably running on Linux or Mac, or maybe
                # cross-compiling Windows using MinGW.
                #
                if entry[:len(prefix) + 3] == 'lib' + prefix :
                    if entry[-2:] == '.a'  :
                        return [ dir, entry ]
                    if entry[-3:] == '.so' :
                        return [ dir, entry ]

                # If the entry start with the prefix and then ends with
                # ".lib" then this looks like its a native Windows build.
                #
                if entry[:len(prefix)] == prefix :
                    if entry[-4:] == '.lib' :
                        return [ dir, entry ]

    return [ None, None ]


def locateLibPair (liblist, dirlist) :

    for dir in dirlist :
        if dir is not None :
            for lib in liblist :
                if os.path.isfile (os.path.join (dir, lib[0])) :
                    return [ dir, lib[1] ]

    return [ None, None ]


def locateExec (file, dirlist = None) :

    if dirlist is None :
        dirlist = string.split (os.environ['PATH'], ':')

    for dir in dirlist :
        if os.path.isfile (os.path.join (dir, file)) :
            return dir

    return None



def stripLibraryName (name) :

    if name[:3] == 'lib'  :
        name = name[3:]

    if name[-2:] == '.a'  :
        name = name[:-2]

    if name[-3:] == '.so' :
        name = name[:-3]

    return name

