import	rkLocator

def Scan (settings) :

    text   = ''

    # We need PyXML, inclusive of xpath, or we cannot process the
    # XML embedded in the python script interface files. Test if these
    # are available, if not then the build will use the processed
    # versions from CVS (and assume thay are up to date).
    #
    try    :
        from xml.dom.ext.reader.Sax2	import FromXmlStream
        from xml.xpath			import Evaluate
        text = text + "pythonXML    = 1\n"
    except :
        text = text + "pythonXML    = 0\n"


    if settings.mode() == 'mac' :

        import distutils.sysconfig

        text = text + "pythonIncDir = '%s'\n" % (distutils.sysconfig.get_config_vars("INCLUDEPY"    )[0])
        text = text + "pythonLink = '%s'\n"   % (distutils.sysconfig.get_config_vars("LINKFORSHARED")[0])
	text = text + "pythonLibDir = None\n"
        text = text + "pythonBuild = 1\n"

        return text


    pyIncList	= settings.optionOrList \
		  (
			'with-python-includes',
			[
				'/usr/local/include/python2.4',
				'/usr/local/include/python2.3',
				'/usr/local/include/python2.2',
				'/usr/local/include/python2.1',
				'/usr/local/include/python2.0',
				'/usr/local/include/python1.5',
				'/usr/include/python2.4',
				'/usr/include/python2.3',
				'/usr/include/python2.2',
				'/usr/include/python2.1',
				'/usr/include/python2.0',
				'/usr/include/python1.5',
			]
		  )

    pyLibList	= settings.optionOrList \
		  (
			'with-python-libraries',
			[
				'/usr/local/lib',
				'/usr/lib',
				'/usr/local/lib/python2.4/config',
				'/usr/local/lib/python2.3/config',
				'/usr/local/lib/python2.2/config',
				'/usr/local/lib/python2.1/config',
				'/usr/local/lib/python2.0/config',
				'/usr/local/lib/python1.5/config',
				'/usr/lib/python2.4/config',
				'/usr/lib/python2.3/config',
				'/usr/lib/python2.2/config',
				'/usr/lib/python2.1/config',
				'/usr/lib/python2.0/config',
				'/usr/lib/python1.5/config'
			]
		  )

    pyIncDir	            = rkLocator.locateFile    ('Python.h', pyIncList )
    [pyLibDir,  pyLibFile]  = rkLocator.locateLibrary ('python',   pyLibList )


    if pyIncDir :
        settings.log   ('Checking for python includes', pyIncDir)
        text = text + "pythonIncDir = r'%s'\n" % (pyIncDir)
    else      :
        settings.log   ('Checking for python includes', 'not found')
        settings.fatal ('python: include files not found')
        text = text + "pythonIncDir = None\n"


    if pyLibDir : 
        settings.log   ('Checking for python libraries', pyLibDir)
        text = text + "pythonLibDir = r'%s'\n" % (pyLibDir)
        text = text + "pythonLib = '%s'\n" % (rkLocator.stripLibraryName(pyLibFile))
    else      :
        settings.log   ('Checking for python libraries', 'not found')
        settings.fatal ('python: development libraries not found')
        text = text + "pythonLibDir = None\n"
        text = text + "pythonLib = None\n"

    if pyIncDir  is not None and pyLibDir  is not None :
        text = text + "pythonBuild  = 1\n"
    else :
        text = text + "pythonBuild  = 0\n"



    return text



def Help (settings) :

    print "	--with-python-includes=dir	: Set python include directory"
    print "	--with-python-libraries=dir	: Set python library directory"
