  <class name="Block" title="Block Methods" super="Item">
    <method name="getNumRows" comment="Number of rows in associated query">
      <return type="number" comment="Number of rows"/>
      <description>
          Returns the number of rows in the query which provides data for
          the block. This is the number of rows returned by the database,
          plus (or minus) subsequent insertions or deletions.
      </description>
    </method>
    <method name="getQueryRow" comment="Get current query row number">
      <return type="number" comment="Row number"/>
      <description>
          Returns the row number (within the rows returned from the database.
          again plus or minus subsequent insertions or deletions) corresponding
          to the current row, that is, the row that has focus (in a form) or
          which is being processed (in a report).
      </description>
    </method>
    <method name="getRowValue" comment="Get value from associated query">
      <return type="string" comment="Value"/>
      <arg name="ctrlName" type="string" comment="Column required, as control name" opt="No"/>
      <arg name="rowNum" type="number" comment="Row number" opt="No"/>
      <description>
          This method returns the value for the specified column (identified by
          the corresponding control name) and row, where the row is the
          row number amongst the data returned by the database. This will
          usually be the same as the value displayed in a form (if the
          record is currently displayed). However, it will be different if the
	  user has edited the displayed value but has not saved the change.
      </description>
    </method>
    <method name="setRowValue" comment="Set value in associated query">
      <return type="void" comment=""/>
      <arg name="ctrlName" type="string" comment="Column required, as control name" opt="No"/>
      <arg name="rowNum" type="number" comment="Row number" opt="No"/>
      <arg name="value" type="string" comment="Value" opt="No"/>
      <description>
          The specified value is stored into the specified column (identified
          by control name) and row in the data returned by the database. Note
          that this will be overwritten if the user subsequently changes
          the value displayed in the corresponding control; also, the value
          will not be saved to the database unless the record is saved.
      </description>
    </method>
    <method name="isInQuery" comment="See if query (find) is in progress">
      <return type="bool" comment="Query (find) in progress"/>
      <description>
          Returns a true result if the block is executing a query, eg.,
          the user has clicked the <emphasis>start query</emphasis> tool
          button.
      </description>
    </method>
    <method name="setUserFilter" comment="Set filter for subsequent queries" serverside="1">
      <return type="void" comment=""/>
      <arg name="filter" type="string" comment="Filter (where) expression" opt="No"/>
      <description>
          Set a filter expression to be used in subsequent queries. This should be
          a valid SQL <i>where</i> expression, and will be used in the query
          in addition to any other filtering expressions.          
      </description>
    </method>
    <method name="setUserSorting" comment="Set sorting for subsequent queries">
      <return type="void" comment=""/>
      <arg name="sorting" type="string" comment="Sorting (order) expression" opt="No"/>
      <description>
          Set an ordering expression to be used in subsequent queries. This
          should be a valid SQL <i>order by</i> expression, and will be used in
          the query in addition to (and after) any other ordering expressions.          
      </description>
    </method>
  </class>
