  <class name="Button" title="Button Methods" super="Object">
    <method name="setText" comment="Set button text">
      <return type="void" comment=""/>
      <arg name="text" type="string" comment="Button text" opt="No"/>
      <description><![CDATA[
      Set the button text to the specified value.
      ]]></description>
    </method>
    <method name="getText" comment="Get button text">
      <return type="string" comment="Button text"/>
      <description><![CDATA[
      Returns the text currently displayed by the button
      ]]></description>
    </method>
    <method name="setPixmaps" comment="Set button images">
      <return type="void" comment=""/>
      <arg name="normal" type="string" comment="Normal image" opt="No"/>
      <arg name="rollover" type="string" comment="Rollover image" opt="No"/>
      <description><![CDATA[
      This method sets the normal and rollover (ie., mouse-over) images for
      the button. The arguments are the names of the images (eg., like
      <emphasis>normal.png</emphasis> and <emphasis>rollover.png</emphasis>).
      Note that button text overlays any images.
      ]]></description>
    </method>
    <method name="setToolTip" comment="Set tooltip">
      <return type="void" comment=""/>
      <arg name="text" type="string" comment="Tool tip" opt="No"/>
      <description><![CDATA[
      Set the tooltip that is displayed when the user hovers the mouse over the
      button.
      ]]></description>
    </method>
    <method name="isOn" comment="Test if button is on">
      <return type="bool" comment="Button is on"/>
      <description><![CDATA[
      This method is used with toggle buttons (ie., buttons where the
      <emphasis>toggle</emphasis> property is set), and checks whether
      the button is <emphasis>on</emphasis> or <emphasis>off</emphasis>.
      ]]></description>
    </method>
    <method name="setOn" comment="Set toggle button on or off">
      <arg name="on" type="bool" comment="On or off" opt="No"/>
      <return type="void" comment=""/>
      <description><![CDATA[
      This method is used with toggle buttons (ie., buttons where the
      <emphasis>toggle</emphasis> property is set), and sets the button to
      the <emphasis>on</emphasis> or <emphasis>off</emphasis> state.
      ]]></description>
    </method>
  </class>
