  <class name="Choice" title="Choice (ComboBox) Methods" super="Item">
    <method name="currentItem" comment="Get current item">
      <return type="number" comment="Currenly selected item number"/>
      <arg name="row" type="number" comment="Row number"/>
      <description><![CDATA[
      The currently selected item is counted from zero. Note that if the
      <emphasis>noblank</emphasis> option is set, then item zero is the
      first real value; if not then it is the entry corresponding to
      a null value.
      ]]></description>
    </method>
    <method name="setCurrentItem" comment="Update current item">
      <return type="void" comment=""/>
      <arg name="row" type="number" comment="Row number"/>
      <arg name="item" type="number" comment="New current item number" opt="No"/>
      <description><![CDATA[
      Sets the current item. Note that if the
      <emphasis>noblank</emphasis> option is set, then item zero is the
      first real value; if not then it is the entry corresponding to
      a null value.
      ]]></description>
    </method>
    <method name="setValues" comment="Load set of choices">
      <return type="void" comment=""/>
      <arg name="values" type="list" comment="List of values as strings" opt="No"/>
      <description><![CDATA[
      This method can be used to set the list of values displayed in the choice
      control. Note that this list should only contain the real values; &rekall;
      will add an extra item corresponding to a null value depending on whether
      the <emphasis>noblank</emphasis> property is set.
      ]]></description>
    </method>
    <method name="getValues" comment="Get current set of choices">
      <return type="list" comment="List of values as strings"/>
      <description><![CDATA[
      This method retrieves the current values that appear in the choice control.
      Note that this list only contains the real values, and will not contain
      an entry corresponding to a null value. A side-effect of this is that,
      depending on whether the <emphasis>noblank</emphasis> property is set,
      a value returned by the <emphasis>currentItem</emphasis> method may be
      offset by one relative to the values returned.
      ]]></description>
    </method>
    <method name="getNumValues" comment="Get current number choices">
      <return type="number" comment="Number"/>
      <description><![CDATA[
      This method retrieves the number of choices that appear in the control,
      except that the entry corresponding to the null value is not
      counted. Hence, unless the <emphasis>noblank</emphasis> property is
      set, this value will be one less than the actual number of entries in
      the choice control.
      ]]></description>
    </method>
    <method name="setValuesFromQuery" comment="Set values from a query">
      <return type="void" comment=""/>
      <arg name="query" type="string" comment="SQL select query" opt="No"/>
      <arg name="args" type="list" comment="Query arguments" opt="Yes"/>
      <arg name="rowNum" type="number" comment="Query row number" opt="Yes"/>
      <description><![CDATA[
          The query is executed, set set of choices set to the first value from
          each record returned; a null value will be prepended unless the
          <i>No Blank</i> property is set. If the row number is not given,
          then the current query row is used.
      ]]></description>
    </method>
  </class>
