/***************************************************************************
    file	         : datetime.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<cppunit/TestCase.h>
#include	<cppunit/TestCaller.h>
#include	<cppunit/TestSuite.h>
#include	<cppunit/extensions/HelperMacros.h>

#include	<qstring.h>
#include	<qmap.h>

#include	"kb_type.h"
#include	"kb_value.h"

#if		defined(__WIN32__)
#define		_STDSTR(s)	((s).isNull() ? "" : (std::string)(s).latin1())
#define		EXPORT_API	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		_STDSTR(s)	(s)
#define		EXPORT_API
#endif

class	KBDateTimeTest : public CppUnit::TestCase
{
public	:

	KBDateTimeTest	() ;
	KBDateTimeTest	(std::string name) ;


	void			testNull	() ;

	static CppUnit::Test	*suite		() ;
}	;

KBDateTimeTest::KBDateTimeTest ()
{
}

KBDateTimeTest::KBDateTimeTest
	(	std::string	name
	)
	:
	CppUnit::TestCase (name)
{
}

void	KBDateTimeTest::testNull ()
{
	KBDateTime dt (QString::null, QString::null) ;
	CPPUNIT_ASSERT (!dt.isValid()) ;
}

CppUnit::Test
	*KBDateTimeTest::suite ()
{
	CppUnit::TestSuite *s = new CppUnit::TestSuite("DateTime") ;
	s->addTest (new CppUnit::TestCaller<KBDateTimeTest> ("testNull",   &KBDateTimeTest::testNull)) ;
	return s ;
}

CppUnit::Test EXPORT_API *dateTimeTestSuite
	(	const QMap<QString,QString> *
	)
{
	return	KBDateTimeTest::suite () ;
}
