/***************************************************************************
    file	         : macro.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<cppunit/TestCase.h>
#include	<cppunit/TestCaller.h>
#include	<cppunit/TestSuite.h>

#include	<qstring.h>
#include	<qmap.h>

#if		defined(__WIN32__)
#define		_STDSTR(s)	((s).isNull() ? "" : (std::string)(s).latin1())
#define		EXPORT_API	__declspec(dllexport)
#endif
#if		! defined(__WIN32__)
#define		_STDSTR(s)	(s)
#define		EXPORT_API
#endif

#include	"kb_libloader.h"

extern	CppUnit::Test	*macro1TestSuite	(const QMap<QString,QString> *) ;

CppUnit::Test EXPORT_API *testSetup
	(	const QMap<QString,QString> *settings
	)
{
	KBLibLoader	*loader  = KBLibLoader::self() ;
	KBLibrary	*exlib   = loader->getLibrary ("lib" __KB_LIBPREFIX "_plugin_extra") ;
	if (exlib == 0)
	{
		fprintf
		(	stderr,
			"Macro::testSetup: no library [%s]\n",
			"lib" __KB_APPNAME "_plugin_extra"
		)	;
		exit	(1) ;
	}
	KBPartFactory	*factory = (KBPartFactory *)exlib->factory() ; 
	if (exlib == 0)
	{
		fprintf
		(	stderr,
			"Macro::testSetup: no factory [%s]\n",
			"lib" __KB_APPNAME "_plugin_extra"
		)	;
		exit	(1) ;
	}
	factory->create (0, 0, 0) ;

//	KBExtraFactory *ef = new KBExtraFactory() ;
//	ef->create (0, 0, 0, QStringList()) ;

	CppUnit::TestSuite *suite = new CppUnit::TestSuite ("Macro") ;
	suite->addTest (macro1TestSuite	(settings))	;
	return	suite	;
}


#include	"kb_libloader.h"
#include	"factory.h"

TESTFACTORY	(KBTestMacroFactory,Macro,rkt_macro)
